#Region AutoIt3Wrapper directives section
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseUpx=Y
#AutoIt3Wrapper_Res_SaveSource=N
#AutoIt3Wrapper_Res_Language=1033
#AutoIt3Wrapper_Res_FileVersion=1.2.0.0
#AutoIt3Wrapper_Res_Description=Hirens BootCD Pro
#AutoIt3Wrapper_Res_LegalCopyright=http://hirens2009.narod.ru/
#AutoIt3Wrapper_Res_Comment=Shell for Hirens Pro
#AutoIt3Wrapper_Res_Field=OriginalFilename|hirenspro.exe
#AutoIt3Wrapper_Res_Field=ProductName|Hirens Pro
#AutoIt3Wrapper_Res_Field=ProductVersion|1.2
#AutoIt3Wrapper_Icon=icons\hirenspro.ico
#AutoIt3Wrapper_OutFile=hirenspro.exe
#AutoIt3Wrapper_Res_File_Add=Main.bmp, 2, 200
#AutoIt3Wrapper_Res_File_Add=wait.avi, AVI, 500
#EndRegion

; Project: Hirens Pro
; Version: 1.2
; Date: 3.10.2012
; Site: http://hirens2009.narod.ru/

#RequireAdmin ;       

#include <GUIConstantsEx.au3> ;  
#include <WindowsConstants.au3> ;  
#include <TreeViewConstants.au3> ;   TreeView
;#include <EditConstants.au3> ;   Edit
#include <GuiEdit.au3> ;   Edit
#include <ScrollBarConstants.au3> ;   Edit
#include <Array.au3> ;   
#include <Constants.au3> ;   Run, RunWait
#include <Encoding.au3> ;     866  1251
#include <StaticConstants.au3> ;   Label
#Include <AVIConstants.au3> ;  AVI-
#Include <Icons.au3> ;     


#NoTrayIcon ;     

Opt("GUIOnEventMode", 1) ;     GUIGetMsg  
Opt("TrayMenuMode",1+2)	;         (Script Paused/Exit)      .
Opt("TrayOnEventMode", 1) ;   TrayOnEventMode.

Local $shell_version = "1.2"
Local $title_gui = "Hirens Pro"
Local $file_conf = @ScriptDir & "\hirens_winprog.txt" ;       
Global $temp_dir = EnvGet("TEMP") ;   %TEMP%

Global Const $SC_MAXIMIZE = 0xF030 ;        ""    

Global $hWnd = GUICreate($title_gui, 610, 392, -1, -1, $GUI_SS_DEFAULT_GUI - $WS_CAPTION) ;  GUI  
GUICtrlSetDefBkColor(0xE4E4DC) ;      

If not @Compiled Then GUISetIcon(@ScriptDir&"\icons\hirenspro.ico") ;  
If @Compiled Then GUISetIcon(@ScriptFullPath, -1)
If @Compiled Then ;     EXE
Local $Fon = GUICtrlCreatePic("", -1, -1, 610, 392) ;  
Local $hInstance = _WinAPI_GetModuleHandle(0) ;    
Local $hBitmap = _WinAPI_LoadBitmap($hInstance, 200) ;       (EXE)   200
_SetHImage($Fon, $hBitmap) ;  
_WinAPI_DeleteObject($hBitmap) ;  
Else ;     EXE
Local $Fon = GUICtrlCreatePic(@ScriptDir&"\Main.jpg", -1, -1, 610, 392) ;     
Endif

GUIRegisterMsg($WM_LBUTTONDOWN,"_DRAG_COMMAND") ;         
GUICtrlSetState($Fon, $GUI_DISABLE) ;   (  ),     
;$ButClose = GUICtrlCreatePic(@ScriptDir&"\MainClose.jpg", 579, 5, 21, 21) ;   
Local $ButClose = GUICtrlCreatePic("", 579, 5, 21, 21) ;    (, ..  , ..      )
GUICtrlSetOnEvent($ButClose, "_Exit")
GUICtrlSetTip($ButClose, "Close") ;     

;            :
Local $contextmenu = GUICtrlCreateContextMenu()
Local $homepagemenu = GUICtrlCreateMenuItem("Homepage", $contextmenu)
GUICtrlSetOnEvent($homepagemenu, "_Homepage")
Local $versionmenu = GUICtrlCreateMenuItem("Version shell", $contextmenu)
GUICtrlSetOnEvent($versionmenu, "_Info")
GUICtrlCreateMenuItem("", $contextmenu) ;  
Local $openfoldermenu = GUICtrlCreateMenuItem("Open folder", $contextmenu)
GUICtrlSetOnEvent($openfoldermenu, "_OpenFolder")
Local $opentempmenu = GUICtrlCreateMenuItem("Open temp", $contextmenu)
GUICtrlSetOnEvent($opentempmenu, "_OpenTemp")
Local $changetempmenu = GUICtrlCreateMenuItem("Change temp", $contextmenu)
GUICtrlSetOnEvent($changetempmenu, "_ChangeTemp")
Local $updatetempmenu = GUICtrlCreateMenuItem("Update temp", $contextmenu)
GUICtrlSetOnEvent($updatetempmenu, "_UpdateTemp")
GUICtrlCreateMenuItem("", $contextmenu) ;  
Local $closetotraymenu = GUICtrlCreateMenuItem("Turn to Tray", $contextmenu)
GUICtrlSetOnEvent($closetotraymenu, "_ToTray")
Local $exitmenu = GUICtrlCreateMenuItem("Exit", $contextmenu)
GUICtrlSetOnEvent($exitmenu, "_Exit")

;    ,   ""  %TEMP%
GUISetFont(8.5) ;    
Global $temp_label = GUICtrlCreateLabel(_Update_temp_label(), 5, 375, 600, 13, $SS_CENTER, $GUI_WS_EX_PARENTDRAG) ;  Label       _Update_temp_label
GUICtrlSetBkColor($temp_label, $GUI_BKCOLOR_TRANSPARENT) ;    Label

GUISetFont(9) ;      GUI-      

;         , , :
Local $file, $line
;     $file_conf
$file = FileOpen($file_conf, 0) ;     
; ,    ,      
If $file = -1 Then
    MsgBox(16+8192, "Error", "   " & $file_conf) ;      
    Exit
EndIf

;            
$line = FileRead($file)
If @error = -1 Then MsgBox(16+8192, "Error", "   " & $file_conf)
    Dim $matchgenitem  = StringRegExp($line, '\[(.*)\]', 3) ;      
 	If @error = 0 Then
	Local $generalcount = UBound($matchgenitem) ;  -  
	Dim $aGeneralitem[$generalcount] ;     -  ,      
	Dim $aGeneraltray[$generalcount] ;     -  ,       ( )
EndIf
FileClose($file) ;  
; :

;           
Local $matchitem = "" ;         
Local $itemcount = -1 ;  ,           
Dim $aParamProg[$generalcount][1] ;        .   -  ,     
Dim $aDescriptProg[$generalcount][1] ;       
$file = FileOpen($file_conf, 0) ;     
While 1 ; 
	$line = FileReadLine($file) ;      
	If @error = -1 Then ExitLoop ;   ,      
    $line = StringStripWS($line, 3) ;        
	Local $match  = StringMid($line, 1, 1) ;     
	Switch $match ;       ,   :
	    Case "[" ;    
			$matchitem = StringRegExp($line, '\[(.*)\]', 1) ;    
			if $matchitem[0] <> "" Then ;      :
			    $itemcount = $itemcount + 1 ;   
				Local $paramcount = 0 ;   ""        $itemcount
				Local $descriptcount = 0 ;     
			EndIf
		Case "#" ;     
			if $matchitem[0] <> "" Then ;      :
				if $paramcount > UBound($aParamProg, 2) - 1 Then ReDim $aParamProg[$generalcount][$paramcount+1] ;    ,       
				$aParamProg[$itemcount][$paramcount] = $line ;      
				$paramcount = $paramcount + 1 ;         (ReDim $aParamProg...)
			EndIf
		Case "*" ;          ,    
			if $matchitem[0] <> "" Then
				if $descriptcount > UBound($aDescriptProg, 2) - 1 Then ReDim $aDescriptProg[$generalcount][$descriptcount+1]
				$descriptline = StringRegExp($line, '\*(.*)\*', 1)
				$aDescriptProg[$itemcount][$descriptcount] = StringReplace($descriptline[0], "\n", @CRLF) ;  "\n"     
				$descriptcount = $descriptcount + 1
			EndIf
	EndSwitch
WEnd
FileClose($file) ;  

;_ArrayDisplay($aParamProg, "$aParamProg")
;_ArrayDisplay($aDescriptProg, "$aDescriptProg")

;   :
; $matchgenitem -       
; $generalcount - -  
; $aGeneralitem -    -  
; $aGeneraltray -    
; $aParamProg -         
; $aDescriptProg -       
;     :
Local $subitemcount = UBound($aParamProg, 2) ;  - 
Dim $aSubitem[$generalcount][$subitemcount] ;         
Dim $aSubtray[$generalcount][$subitemcount] ;           

;           ,   TreeView
;Local $StileTreeView = BitOR($GUI_SS_DEFAULT_TREEVIEW, $TVS_TRACKSELECT) ;  TreeView
Global $treeview = GUICtrlCreateTreeView(9, 37, 286, 330, -1, $WS_EX_TRANSPARENT) ;  TreeView  
Global $description = GUICtrlCreateEdit("", 308, 37, 293, 330, BitOR($ES_MULTILINE, $WS_VSCROLL, $ES_READONLY), $WS_EX_TRANSPARENT) ;      

;   TreeView:
Local $icon_Subitem = @ScriptDir & "\icons\shortcut.ico" ;    
if not FileExists($icon_Subitem) Then $icon_Subitem = ""
;   ,     :
For $j = 0 To $generalcount - 1 ;      
	$aGeneralitem[$j] = GUICtrlCreateTreeViewItem($matchgenitem[$j], $treeview) ;   $aGeneralitem        
	;GUICtrlSetOnEvent($aGeneralitem[$j], "_SelectItem") ;          
	$icon_patch = @ScriptDir&"\icons\" & $matchgenitem[$j] & ".ico" ;      
	if FileExists($icon_patch) Then GUICtrlSetImage($aGeneralitem[$j], $icon_patch) ;         
	For $i = 0 To UBound($aSubitem, 2) - 1 ;      
		if $aParamProg[$j][$i] <> "" Then ;   :
		$aProg = StringSplit($aParamProg[$j][$i], "#", 2) ;    
		$aSubitem[$j][$i] = GUICtrlCreateTreeViewItem($aProg[3], $aGeneralitem[$j]) ;  ,           ($aProg[3])
		;GUICtrlSetOnEvent($aSubitem[$j][$i], "_SelectSubItem") ;             
		if $icon_Subitem <> "" Then GUICtrlSetImage($aSubitem[$j][$i], $icon_Subitem) ;       
		EndIf
	Next
Next

_WinAPI_RemoveMenu($hWnd, $SC_MAXIMIZE) ;            ""     
GUIRegisterMsg($WM_NOTIFY, "_WM_NOTIFY") ;  ,      
GUISetState(@SW_SHOW, $hWnd) ;   

;   Tray:
If not @Compiled Then TraySetIcon(@ScriptDir&"\icons\hirenspro.ico")
If @Compiled Then TraySetIcon(@ScriptFullPath, -1)
For $j = 0 To $generalcount - 1 ;      
	$aGeneraltray[$j] = TrayCreateMenu($matchgenitem[$j]) ;   $aGeneraltray        
	For $i = 0 To UBound($aParamProg, 2) - 1 ;      
		if $aParamProg[$j][$i] <> "" Then ;   :
		$aProg = StringSplit($aParamProg[$j][$i], "#", 2) ;    
		$aSubtray[$j][$i] = TrayCreateItem($aProg[3], $aGeneraltray[$j]) ;  ,           ($aProg[3])
		TrayItemSetOnEvent(-1, "_Select_tray")
		EndIf
	Next
Next

;_ArrayDisplay($aGeneralitem, "$aGeneralitem")
;_ArrayDisplay($aSubitem, "$aSubitem")

TrayCreateItem("") ;  
Local $trayOpenFolder = TrayCreateItem("Open folder")
TrayItemSetOnEvent($trayOpenFolder, "_OpenFolder")
Local $trayOpenTemp = TrayCreateItem("Open temp")
TrayItemSetOnEvent($trayOpenTemp, "_OpenTemp")
Local $trayChangeTemp = TrayCreateItem("Change temp")
TrayItemSetOnEvent($trayChangeTemp, "_ChangeTemp")
TrayCreateItem("") ;  
Local $trayAbout = TrayCreateItem("Version shell")
TrayItemSetOnEvent($trayAbout, "_Info")
Local $trayHomepage = TrayCreateItem("Home page")
TrayItemSetOnEvent($trayHomepage, "_Homepage")
TrayCreateItem("") ;  
Local $trayShowGUI = TrayCreateItem("Show GUI")
TrayItemSetOnEvent($trayShowGUI, "_ShowGUI")
Local $trayExit = TrayCreateItem("Exit")
TrayItemSetOnEvent($trayExit, "_Exit")
TraySetState(2)

;  
While 1
    Sleep(10)
WEnd

;  
Func _Homepage()
	ShellExecute('http://hirens2009.narod.ru/')
EndFunc

;     
Func _OpenFolder()
	;ShellExecute(@ScriptDir)
	;Run(@WindowsDir & '\explorer.exe "' & @ScriptDir & '"')
	ShellExecute("explorer.exe", @ScriptDir, @WindowsDir, "open")
EndFunc

;   %TEMP%
Func _OpenTemp()
	;ShellExecute($temp_dir)
	;Run(@WindowsDir & 'explorer.exe "' & $temp_dir & '"')
	ShellExecute("explorer.exe", $temp_dir, @WindowsDir, "open")
EndFunc

;    %TEMP%
Func _ChangeTemp()
	$new_temp_dir = FileSelectFolder("    TEMP." & @CRLF & _
	" TEMP      !" & @CRLF & " TEMP: " & $temp_dir, "", 3, @DesktopDir, $hWnd)
	If FileExists($new_temp_dir) Then
		EnvSet("TEMP", $new_temp_dir)
		GUICtrlSetData($temp_label, _Update_temp_label())
	EndIf
EndFunc

;  Label     
Func _UpdateTemp()
	GUICtrlSetData($temp_label, _Update_temp_label())
EndFunc

;   
Func _Info()
    MsgBox(0+64+4096, $title_gui, "Shell ver. " & $shell_version)
EndFunc

; 
Func _Exit()
    Exit
EndFunc

;        
Func _ShowGUI()
	GUISetState(@SW_SHOW, $hWnd) ;   
	TraySetState(2) ;    
EndFunc

;        
Func _ToTray()
	GUISetState(@SW_HIDE, $hWnd) ;   
	TraySetState(1) ;    
	TraySetToolTip($title_gui) ;  -
EndFunc

;     ,   
Func _Select_tray()
	$sSubtray = _ArraySearch($aSubtray, @TRAY_ID) ;      
	If @error == 0 Then ;  , :
		For $i = 0 To UBound($aParamProg, 2) - 1 ;   ,    :
			$t = $aSubtray[$sSubtray][$i] ;         $aSubtray[$sSubtray]
			; :       ,    ,            $aParamProg
			if $t == @TRAY_ID Then
				$aProg = StringSplit($aParamProg[$sSubtray][$i], "#", 2) ;   
				if IsArray($aProg) Then _Run_Select_Prog($aProg) ;  
			EndIf
		Next
	EndIf
EndFunc

;   
Func _DRAG_COMMAND($hWnd)
If BitAND(WinGetState($hWnd),32) Then Return
DllCall("user32.dll","long","SendMessage","hwnd",$hWnd,"int",$WM_SYSCOMMAND,"int",0xF009,"int",0)
EndFunc

;    ,         
Func _WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
    #forceref $hWnd, $iMsg, $iwParam
    Local $hWndFrom, $iCode, $tNMHDR, $hWndTreeview, $hReadTreeview
    $hWndTreeview = $treeview
    If Not IsHWnd($treeview) Then $hWndTreeview = GUICtrlGetHandle($treeview)
	;$hReadTreeview = _GUICtrlTreeView_GetSelection($hWndTreeview) ;    
	$hReadTreeview = GUICtrlRead($treeview)
    $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
    $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
    $iCode = DllStructGetData($tNMHDR, "Code")
    Switch $hWndFrom
        Case $hWndTreeview
            Switch $iCode
				Case $NM_DBLCLK;    (    -   )     
					$sSubitem = _ArraySearch($aSubitem, $hReadTreeview) ;    
					If @error == 0 Then ;  , :
						For $i = 0 To UBound($aParamProg, 2) - 1 ;   ,    :
							$t = $aSubitem[$sSubitem][$i] ;         $aSubitem[$sSubitem]
							; :       ,    ,            $aParamProg
							if $t = $hReadTreeview Then
								$aProg = StringSplit($aParamProg[$sSubitem][$i], "#", 2) ;   
								if IsArray($aProg) Then _Run_Select_Prog($aProg) ;  
								ExitLoop
							EndIf
						Next
					EndIf
					Return 0
				Case $TVN_SELCHANGEDA, $TVN_SELCHANGEDW ;    
					$sGeneralitem = _ArraySearch($aGeneralitem, $hReadTreeview) ;      
					If @error == 0 Then
						GUICtrlSetData($description, GUICtrlRead($treeview,1)) ;  ,        
					Else
						$sSubitem = _ArraySearch($aSubitem, $hReadTreeview) ;    
						If @error == 0 Then ;  , :
							GUICtrlSetData($description, GUICtrlRead($treeview,1)) ;   $description    ( )
							For $i = 0 To UBound($aDescriptProg, 2) - 1 ;     ,   ,    
								$t = $aSubitem[$sSubitem][$i] ;         $aSubitem[$sSubitem]
								; :       ,    ,            $aDescriptProg
								;  ,    $description  ,     $description      "\n"     
								if $t = $hReadTreeview Then
									GUICtrlSetData($description, @CRLF & @CRLF & $aDescriptProg[$sSubitem][$i],1) ;    
									_GUICtrlEdit_Scroll($description, $SB_TOP) ;     
									ExitLoop
								EndIf
							Next
						EndIf
					EndIf
					Return 0
			EndSwitch
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc

; ,   
Func _Run_Select_Prog($aProg)
	; : $aProg[1] -       %TEMP%, $aProg[2] -  
	$archive = StringStripWS($aProg[1], 3) ;         
	$prog_and_param = StringStripWS($aProg[2], 3) ;    ,       
	$paramSearch = StringInStr($prog_and_param, "|") ;   "|" (  )
	if $paramSearch > 0 Then ;    
		$start_prog = StringLeft($prog_and_param, $paramSearch-1) ;    
		$start_param = StringMid($prog_and_param, $paramSearch+1) ;  
	Else
		$start_prog = $prog_and_param
		$start_param = ""
	EndIf
	if $archive <> "" Then ;    , 
		$archive_patch = @ScriptDir & "\programs\" & $archive & ".7z" ;     7z
		if not FileExists($archive_patch) Then
			MsgBox(16+8192, "Error", ": " & $archive_patch & "  !")
		Else
			$7z_patch = @ScriptDir & "\programs\7z.exe" ;    7z
			if not FileExists($7z_patch) Then
				MsgBox(16+8192, "Error", ": " & $7z_patch & "  !")
			Else
				;RunWait($7z_patch & ' x -o"' & $temp_dir & '\' & $archive & '"' & ' -y ' & $archive_patch, @ScriptDir)
				Local $sOut = ""
				Local $sOutMes = ""
				;$iPID = Run(@ComSpec & ' /C "' & $7z_patch & ' x -o""' & $temp_dir & '\' & $archive & '""' & ' -y ' & $archive_patch & '"', @ScriptDir, @SW_HIDE, $STDERR_CHILD + $STDOUT_CHILD)
				$GUI_popup = GUICreate("", 220, 40, -1, -1, BitOR($WS_DLGFRAME, $WS_POPUP), $WS_EX_TOPMOST, $hWnd) ;     
				If @Compiled Then GUICtrlCreateAvi(@ScriptFullPath, 500, 5, 3, 32, 32, $ACS_AUTOPLAY)
				If not @Compiled Then GUICtrlCreateAvi(@ScriptDir & "\wait.avi", "", 5, 3, 32, 32, $ACS_AUTOPLAY)
				GUICtrlCreateLabel("Please wait....", 37, 12, 183, 15, $SS_CENTER)
				GUISetState(@SW_SHOW, $GUI_popup)
				Sleep(100)
				$iPID = Run($7z_patch & ' x -o"' & $temp_dir & '\' & $archive & '"' & ' -y "' & $archive_patch & '"', @ScriptDir, @SW_HIDE, $STDOUT_CHILD)
				While 1
					$sOut = StdoutRead($iPID)
					If @error Then ExitLoop
					if $sOut <> "" Then $sOutMes &= $sOut
					Sleep(1)
				Wend
				GUIDelete($GUI_popup)
				$fStdoutRead = $temp_dir & "\_StdoutRead.txt"
				if FileExists($fStdoutRead) Then FileDelete($fStdoutRead)
				if $sOutMes <> "" Then FileWrite($fStdoutRead, StringReplace(_Encoding_866To1251($sOutMes), @CR, @CRLF))
				GUICtrlSetData($temp_label, _Update_temp_label())
				if not FileExists($temp_dir & '\' & $archive & '\' & $start_prog) Then
					if $sOutMes <> "" Then
						$sMessErrOut = @CRLF & @CRLF & "  Stdout?"
						$iIDicon = 4
					Else
						$sMessErrOut = ""
						$iIDicon = 0
					EndIf
					$mID = MsgBox($iIDicon+16+8192, "Error", ": " & $temp_dir & '\' & $archive & '\' & $start_prog & "  !" & $sMessErrOut)
					;if $mID = 6 Then MsgBox(48+8192, "Stdout info", _Encoding_866To1251($sOutMes))
					if $mID = 6 and FileExists($fStdoutRead) Then ShellExecute($fStdoutRead, "", @ScriptDir, "open")
				Else
					Run('"' & $temp_dir & '\' & $archive & '\' & $start_prog & '"' & ' ' & $start_param, $temp_dir & '\' & $archive)
				EndIf
			EndIf
		EndIf
	Else ;    
		$start_prog_patch = @ScriptDir & "\programs\" & $start_prog ;     
		if not FileExists($start_prog_patch) Then
			MsgBox(16+8192, "Error", ": " & $start_prog_patch & "  !")
		Else
			Run('"' & $start_prog_patch & '"' & ' ' & $start_param, @ScriptDir & "\programs")
		EndIf
	EndIf
EndFunc


;      
Func _WinAPI_RemoveMenu($hWnd, $iFlag)
    Local $aMenu = DllCall("User32.dll", "hwnd", "GetSystemMenu", "hwnd", $hWnd, "int", 0)
    If @error Then Return SetError(1)
    DllCall("User32.dll", "int", "RemoveMenu", "hwnd", $aMenu[0] , "int", $iFlag, "int", 0x0)
EndFunc

;       TEMP     ,   TEMP
Func _Update_temp_label()
	Global $temp_dir = EnvGet("TEMP")
	Return "Curent TEMP: " & $temp_dir & " (Free space: " & Int(DriveSpaceFree($temp_dir & "\")) & " mb)"
EndFunc
